#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;

const int L = 61, N = 300003, MOD = 1e9 + 7;
ll pc[L], c[L][L], pt[L][L], rep[L], f[N];
ll dp[L][N];
int n, m;
ll k, ans;

ll pw(ll x, ll p) {
    if (!p)
        return 1;
    if (p % 2)
        return pw(x, p - 1) * x % MOD;
    return pw(x * x % MOD, p / 2);
}
ll addm(ll x, ll y) {
    ll s = x + y;
    return s >= MOD ? s - MOD : s;
}
ll subm(ll x, ll y) {
    ll s = x - y;
    return s < 0 ? s + MOD : s;
}
ll mulm(ll x, ll y) {
    return x * y % MOD;
}
ll divm(ll x, ll y) {
    return x * pw(y, MOD - 2) % MOD;
}
ll comb(ll n, ll k) {
    if (n < k)
        return 0;
    return divm(f[n], mulm(f[k], f[n - k]));
}

int main() {
    //ios_base::sync_with_stdio(0); cin.tie(0);
    f[0] = 1;
    for (int i = 1; i < N; i++)
        f[i] = mulm(f[i - 1], i);
    for (int i = 0; i < L; i++) {
        c[i][0] = 1;
        for (int j = 1; j <= i; j++)
            c[i][j] = addm(c[i - 1][j], c[i - 1][j - 1]);
    }
    pt[0][0] = 1;
    for (int i = 1; i < L; i++) {
        for (int j = 1; j < L; j++) {
            for (int k = 1; k <= i; k++)
                pt[i][j] = addm(pt[i][j], mulm(pt[i - k][j - 1], c[i][k]));
            //cout << pt[i][j] << ' ';
        }
        //cout << '\n ';
    }
    cin >> n >> m >> k;
    k++;
    int s = 0;
    for (int i = L - 1; i >= 0; i--) {
        if (k & (1ll << i)) {
            for (int j = 0; j <= i; j++)
                pc[s + j] = addm(pc[s + j], c[i][j]);
            s++;
        }
    }
    for (int i = 0; i < L; i++)
        for (int j = 0; j <= i; j++)
            rep[j] = addm(rep[j], mulm(pc[i], pt[i][j]));
    if (m == 0) {
        for (int i = 0; i < L; i++)
            ans = addm(ans, mulm(rep[i], comb(n, i)));
        cout << ans;
        return 0;
    }
    vector<pair<int, int>> a, ca(m);
    for (int i = 0; i < m; i++) {
        cin >> ca[i].first >> ca[i].second;
        ca[i].first--;
        ca[i].second--;
    }
    sort(ca.begin(), ca.end());
    for (auto &pp : ca) {
        if (!a.empty() && a.back().first == pp.first)
            continue;
        while (!a.empty() && a.back().second >= pp.second)
            a.pop_back();
        a.push_back(pp);
    }
    //for (int i = 0; i < L; i++)
    //   cout << i << ' ' << pc[i] << '\n';
    m = a.size();
    int pos = m;
    dp[0][n] = 1;
    for (int i = n - 1; i >= 0; i--) {
        while (pos > 0 && a[pos - 1].first >= i)
            pos--;
        dp[1][i] = addm(dp[1][i + 1], pos == m ? 1 : 0);
        for (int j = 2; j < L; j++) {
            dp[j][i] = addm(dp[j][i + 1], subm(dp[j - 1][i + 1], dp[j - 1][(pos == m ? n : a[pos].second) + 1]));
        }
    }
    for (int i = 1; i < L; i++) {
        /*for (int j = 0; j <= n + 1; j++)
            cout << dp[i][j] << ' ';
        cout << '\n';*/
        ans = addm(ans, mulm(rep[i], subm(dp[i][0], dp[i][a[0].second + 1])));
    }
    cout << ans;
}
