#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;

const int L = 61, N = 300002, MOD = 1e9 + 7;
ll pc[L], c[L][L], pt[L][L], rep[L], f[N];
int n, m;
ll k, ans;

ll pw(ll x, ll p) {
    if (!p)
        return 1;
    if (p % 2)
        return pw(x, p - 1) * x % MOD;
    return pw(x * x % MOD, p / 2);
}
ll addm(ll x, ll y) {
    ll s = x + y;
    return s >= MOD ? s - MOD : s;
}
ll mulm(ll x, ll y) {
    return x * y % MOD;
}
ll divm(ll x, ll y) {
    return x * pw(y, MOD - 2) % MOD;
}
ll comb(ll n, ll k) {
    if (n < k)
        return 0;
    return divm(f[n], mulm(f[k], f[n - k]));
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    f[0] = 1;
    for (int i = 1; i < N; i++)
        f[i] = mulm(f[i - 1], i);
    for (int i = 0; i < L; i++) {
        c[i][0] = 1;
        for (int j = 1; j <= i; j++)
            c[i][j] = addm(c[i - 1][j], c[i - 1][j - 1]);
    }
    pt[0][0] = 1;
    for (int i = 1; i < L; i++) {
        for (int j = 1; j < L; j++) {
            for (int k = 1; k <= i; k++)
                pt[i][j] = addm(pt[i][j], mulm(pt[i - k][j - 1], c[i][k]));
            //cout << pt[i][j] << ' ';
        }
        //cout << '\n ';
    }
    cin >> n >> m >> k;
    k++;
    int s = 0;
    for (int i = L - 1; i >= 0; i--) {
        if (k & (1ll << i)) {
            for (int j = 0; j <= i; j++)
                pc[s + j] = addm(pc[s + j], c[i][j]);
            s++;
        }
    }
    for (int i = 0; i < L; i++)
        for (int j = 0; j <= i; j++)
            rep[j] = addm(rep[j], mulm(pc[i], pt[i][j]));
    for (int i = 0; i < L; i++) {
        ans = addm(ans, mulm(rep[i], comb(n, i)));
    }
    cout << ans;
    //for (int i = 0; i < L; i++)
    //   cout << i << ' ' << pc[i] << '\n';

}

