#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 300002;
int a[N], used[N], dp1[N], dp2[N];
vector<int> g[N];

void dfs(int v) {
    int mx = 0;
    for (int u : g[v]) {
        dfs(u);
        dp1[v] += dp2[u];
        dp2[v] += dp1[u];
    }
    dp2[v]++;
    dp2[v] = max(dp2[v], dp1[v]);
}

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 0)
            a[i]--;
    }
    vector<vector<int>> l;
    for (int i = 0; i < n; i++) {
        if (used[i])
            continue;
        int v = i;
        while (v >= 0 && !used[v]) {
            used[v] = i + 1;
            v = a[v];
        }
        if (v >= 0 && used[v] == i + 1) {
            l.emplace_back();
            while (used[v] == i + 1) {
                used[v] = -1;
                l.back().push_back(v);
                v = a[v];
            }
        }
    }
    for (int i = 0; i < n; i++)
        if (used[i] != -1    && a[i] != -1)
            g[a[i]].push_back(i);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == -1) {
            dfs(i);
            ans += dp2[i];
        }
        else if (used[i] == -1)
            dfs(i);
    }
    for (auto &w : l) {
        int k = w.size();
        vector<vector<int>> dp(4, vector<int>(k));
        dp[3][0] = dp2[w[0]];
        dp[0][0] = dp[1][0] = dp[2][0] = dp1[w[0]];
        for (int i = 1; i < k; i++) {
            dp[0][i] = dp1[w[i]] + dp[1][i - 1];
            dp[1][i] = max(dp[0][i], dp2[w[i]] + dp[0][i - 1]);
            dp[2][i] = dp1[w[i]] + dp[3][i - 1];
            dp[3][i] = max(dp[2][i], dp2[w[i]] + dp[2][i - 1]);
        }
        ans += max(dp[1][k - 1], dp[2][k - 1]);
    }
    cout << ans;
}
